#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>

#define MAXLEN 1024

/* This code works on Zeus! */
int main()
{
  /* dup2()  makes newfd be the copy of oldfd, 
   * closing newfd first if necessary.
   */

	char data[MAXLEN];
	int fd;
	int pid;

	fd = open("test.txt", O_WRONLY | O_CREAT | O_TRUNC, S_IRWXU);
	dup2(fd, STDOUT_FILENO);

	fprintf(stderr,"> ");
	fgets(&(data[0]),MAXLEN,stdin);

	pid = fork();

	write(fd, &(data[0]), strlen(data)+1);
	
	printf("DATA %s\n", data);
	printf("PID %d\n", pid);
	
	close(fd);
	
	printf("ONCE MORE: %s\n", data);
}
