#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#define MAXSIZE 1024
#define WRITE 1
#define READ 0

void readFromCommandLine(char *data, int maxSize) {
	fprintf(stderr,"> ");
	fgets(data, maxSize, stdin);
}

/* Find the bug in this code
 * What is it trying to do?
 * What erroneous behavior does it exhibit?
 * Why
 */
int main() {
	char data[MAXSIZE + 1];
	int thePipe[2];
	pid_t childPid;
	int status;

	pipe(thePipe);
	childPid = fork();
	if (childPid == 0) {
		
		/* I AM A CHILD */
		
		while (read(thePipe[READ], data, MAXSIZE) > 0) {
			printf("CHILD> %s\n", data);
		}
		close(thePipe[READ]);
	} else {
		
		/* parent */

		readFromCommandLine(data, MAXSIZE);
		while (strncmp(data, "STOP", 4) != 0) {
			write(thePipe[WRITE], data, strlen(data)+1);
			readFromCommandLine(data, MAXSIZE);
		}
		close(thePipe[WRITE]);
		waitpid(childPid, &status, 0);
	}
}
